var SOAPClient_operationID = 0;
var imgFormat = 0;

var propertyEnumSOAP = {
		AcquisitionMode : 0,
		ImageFormat : 1,
		SessionTimeout : 2,
		PrinterEnable : 3,
		PrinterString : 4,
}

function SOAPClient() {}

SOAPClient.invoke = function(method, index, value, async)
{
	if (async)
		SOAPClient._sendSoapRequest(method, index, value, async);
	else
		return SOAPClient._sendSoapRequest(method, index, value, async);
}

SOAPClient._sendSoapRequest = function(method, index, value, async)
{
	// build SOAP request
	var xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> " +
			  "<SOAP-ENV:Envelope " +
			  "xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\" " +
			  "xmlns:SOAP-ENC=\"http://schemas.xmlsoap.org/soap/encoding/\" " + 
			  "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" " +
			  "xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" " +
			  "xmlns:ns=\"urn:MicroREIService\">" +
			  "<SOAP-ENV:Body  SOAP-ENV:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\">" +
				"<ns:Service>" +
				  "<request> " +
					"<OperationID>" + SOAPClient_operationID + "</OperationID>" +
					"<Code>" + method + "</Code>" +
					"<Index>" + index + "</Index>" +
					"<Value>" + value + "</Value>" +
				  "</request>" +
				"</ns:Service>" +
			  "</SOAP-ENV:Body>" +
			  "</SOAP-ENV:Envelope>";

	// send request
	var xmlHttp = SOAPClient._getXmlHttp();
	xmlHttp.open('POST', 'MicroREIService', async);
	xmlHttp.setRequestHeader("Content-Type", "text/xml; charset=utf-8");
	
	if (async)
	{
		xmlHttp.onreadystatechange = function()
		{
			if (xmlHttp.readyState == 4 && xmlhttp.status == 200)
				SOAPClient._onSendSoapRequest(method, index, value, xmlHttp);
		}
	}
	
	xmlHttp.send(xml);
	
	if (!async)
		return SOAPClient._onSendSoapRequest(method, index, value, xmlHttp);
}

SOAPClient._onSendSoapRequest = function(method, index, value, req)
{
	if (req.responseXML == null)
	  return false;
	
	var elementResult = SOAPClient._getElementsByTagName(req.responseXML, "Result");
	var elementValue = SOAPClient._getElementsByTagName(req.responseXML, "Value");
	if ((elementResult == null) || (elementValue == null))
	  return false;
	
	var resResult = SOAPClient._getNodeValue(elementResult);
	var resValue = SOAPClient._getNodeValue(elementValue);
	if ((resResult == null) || (resValue == null))
	  return false;
	
	if (resResult == '0')
	{
		switch (method)
		{
		case "Connect":
			SOAPClient_operationID = resValue;
			
			break;
			
		case "Disconnect":
			SOAPClient_operationID = 0;
			
			break;
	
		case "GetProperty":
			switch (index)
			{
			case propertyEnumSOAP.AcquisitionMode:

				break;
			
			case propertyEnumSOAP.ImageFormat:

				break;
				
			case propertyEnumSOAP.SessionTimeout:

				break;
				
			case propertyEnumSOAP.PrinterEnable:

				break;
				
			case propertyEnumSOAP.PrinterString:

				break;
			}
			
			break;
			
		case "SetProperty":
			switch (index)
			{
			case propertyEnumSOAP.AcquisitionMode:

				break;
			
			case propertyEnumSOAP.ImageFormat:
				imgFormat = parseInt(value, 10);
				break;
				
			case propertyEnumSOAP.SessionTimeout:

				break;
				
			case propertyEnumSOAP.PrinterEnable:

				break;
				
			case propertyEnumSOAP.PrinterString:

				break;
			}
			
			break;
			
		case "AcquireScanner":
			document.getElementById("document").innerHTML = "Document 1 of " + resValue;
			document.getElementById("totDocumentsBox").value = resValue;
			
			var frontImage = document.getElementById("frontImg");
			if(frontImage && frontImage.style)
			{
			  //frontImage.style.height = '100px';
			  frontImage.style.width = '45%';
			  frontImage.src = "img_1_f" + (imgFormat == 0 ? ".bmp" : (imgFormat == 1 ? ".jpg" : ".tif")) + "?data=" + escape(new Date());
			}
				  
			var backImage = document.getElementById("backImg");
			if(backImage && backImage.style)
			{
			  //backImage.style.height = '100px';
			  backImage.style.width = '45%';
			  backImage.src = "img_1_b" + (imgFormat == 0 ? ".bmp" : (imgFormat == 1 ? ".jpg" : ".tif")) + "?data=" + escape(new Date());
			}
			
			var button = document.getElementById("previousDoc");
			button.disabled = true;
			
			button = document.getElementById("firstDoc");
			button.disabled = true;
			
			button = document.getElementById("nextDoc");
			button.disabled = false;

			button = document.getElementById("lastDoc");
			button.disabled = false;
			
			break;
		}
  } 
  else
  {
	  alert(resValue);

	  return false
  }
	
  return true;
}

SOAPClient._getElementsByTagName = function(document, tagName)
{
	return document.getElementsByTagName(tagName)[0];
}

SOAPClient._getNodeValue = function(node)
{
	if (node == null)
		return null;
	
	if (node.textContent != null)
		return node.textContent;
	else if (node.nodeValue != null)
		return node.nodeValue;
	else if(node.nodeTypedValue != null)
		return node.nodeTypedValue;
	else
		return node.innerHTML;
}

SOAPClient._getXmlHttp = function() 
{
	try
	{
		if (window.XMLHttpRequest)
		{
			var xhttp = new XMLHttpRequest();
			if (xhttp.readyState == null)
			{
				xhttp.readyState = 1;
				xhttp.addEventListener("load", 
				function() 
				{
					xhttp.readyState = 4;
					if (typeof xhttp.onreadystatechange == "function")
						xhttp.onreadystatechange();
				}, false);
			}
			
			return xhttp;
		}
		
		if (window.ActiveXObject) 
			return new ActiveXObject(SOAPClient._getXmlHttpProgID());
	}
	catch (ex) {}
	
	throw new Error("Your browser does not support XmlHttp objects");
}

SOAPClient._getXmlHttpProgID = function()
{
	if (SOAPClient._getXmlHttpProgID.progid)
		return SOAPClient._getXmlHttpProgID.progid;
  
	var progids = ["Msxml2.XMLHTTP.5.0", "Msxml2.XMLHTTP.4.0", "MSXML2.XMLHTTP.3.0", "MSXML2.XMLHTTP", "Microsoft.XMLHTTP"];
	var o;
	for (var i = 0; i < progids.length; i++)
	{
		try
		{
			o = new ActiveXObject(progids[i]);
			return SOAPClient._getXmlHttpProgID.progid = progids[i];
		}
		catch (ex) {};
	}
	
	throw new Error("Could not find an installed XML parser");
}